1 # SPDX-License-Identifier: GPL-2.0+
10 # To see a list of typical targets execute "make help"
11 # More info can be located in ./README
12 # Comments in this file are targeted only to the developer, do not
13 # expect to learn how to build the kernel reading this file.
15 # Do not use make's built-in rules and variables
16 # (this increases performance and avoids hard-to-debug behaviour)
19 # Determine target architecture for the sandbox
20 include include/host_arch.h
21 ifeq ("", "$(CROSS_COMPILE)")
22 MK_ARCH="${shell uname -m}"
24 MK_ARCH="${shell echo $(CROSS_COMPILE) | sed -n 's/^\s*\([^\/]*\/\)*\([^-]*\)-\S*/\2/p'}"
27 ifeq ("x86_64", $(MK_ARCH))
28 export HOST_ARCH=$(HOST_ARCH_X86_64)
29 else ifneq (,$(findstring $(MK_ARCH), "i386" "i486" "i586" "i686"))
30 export HOST_ARCH=$(HOST_ARCH_X86)
31 else ifneq (,$(findstring $(MK_ARCH), "aarch64" "armv8l"))
32 export HOST_ARCH=$(HOST_ARCH_AARCH64)
33 else ifneq (,$(findstring $(MK_ARCH), "arm" "armv7" "armv7l"))
34 export HOST_ARCH=$(HOST_ARCH_ARM)
35 else ifeq ("riscv32", $(MK_ARCH))
36 export HOST_ARCH=$(HOST_ARCH_RISCV32)
37 else ifeq ("riscv64", $(MK_ARCH))
38 export HOST_ARCH=$(HOST_ARCH_RISCV64)
42 # Avoid funny character set dependencies
46 export LC_COLLATE LC_NUMERIC
48 # Avoid interference with shell env settings
51 # We are using a recursive build, so we need to do a little thinking
52 # to get the ordering right.
54 # Most importantly: sub-Makefiles should only ever modify files in
55 # their own directory. If in some directory we have a dependency on
56 # a file in another dir (which doesn't happen often, but it's often
57 # unavoidable when linking the built-in.o targets which finally
58 # turn into vmlinux), we will call a sub make in that other dir, and
59 # after that we are sure that everything which is in that other dir
62 # The only cases where we need to modify files which have global
63 # effects are thus separated out and done before the recursive
64 # descending is started. They are now explicitly listed as the
68 # ---------------------------------------------------------------------------
70 # Normally, we echo the whole command before executing it. By making
71 # that echo $($(quiet)$(cmd)), we now have the possibility to set
72 # $(quiet) to choose other forms of output instead, e.g.
74 # quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
75 # cmd_cc_o_c = $(CC) $(c_flags) -c -o $@ $<
77 # If $(quiet) is empty, the whole command will be printed.
78 # If it is set to "quiet_", only the short version will be printed.
79 # If it is set to "silent_", nothing will be printed at all, since
80 # the variable $(silent_cmd_cc_o_c) doesn't exist.
82 # A simple variant is to prefix commands with $(Q) - that's useful
83 # for commands that shall be hidden in non-verbose mode.
87 # If KBUILD_VERBOSE equals 0 then the above command will be hidden.
88 # If KBUILD_VERBOSE equals 1 then the above command is displayed.
90 # To put more focus on warnings, be less verbose as default
91 # Use 'make V=1' to see the full commands
93 ifeq ("$(origin V)", "command line")
100 ifeq ($(KBUILD_VERBOSE),1)
108 # If the user is running make -s (silent mode), suppress echoing of
111 ifneq ($(filter 4.%,$(MAKE_VERSION)),) # make-4
112 ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
116 ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
121 export quiet Q KBUILD_VERBOSE
123 # kbuild supports saving output files in a separate directory.
124 # To locate output files in a separate directory two syntaxes are supported.
125 # In both cases the working directory must be the root of the kernel src.
127 # Use "make O=dir/to/store/output/files/"
129 # 2) Set KBUILD_OUTPUT
130 # Set the environment variable KBUILD_OUTPUT to point to the directory
131 # where the output files shall be placed.
132 # export KBUILD_OUTPUT=dir/to/store/output/files/
135 # The O= assignment takes precedence over the KBUILD_OUTPUT environment
138 # KBUILD_SRC is set on invocation of make in OBJ directory
139 # KBUILD_SRC is not intended to be used by the regular user (for now)
140 ifeq ($(KBUILD_SRC),)
142 # OK, Make called in directory where kernel src resides
143 # Do we want to locate output files in a separate directory?
144 ifeq ("$(origin O)", "command line")
145 KBUILD_OUTPUT := $(O)
148 # That's our default target when none is given on the command line
152 # Cancel implicit rules on top Makefile
153 $(CURDIR)/Makefile Makefile: ;
155 ifneq ($(KBUILD_OUTPUT),)
156 # Invoke a second make in the output directory, passing relevant variables
157 # check that the output directory actually exists
158 saved-output := $(KBUILD_OUTPUT)
159 KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
161 $(if $(KBUILD_OUTPUT),, \
162 $(error failed to create output directory "$(saved-output)"))
164 # Look for make include files relative to root of kernel src
166 # This does not become effective immediately because MAKEFLAGS is re-parsed
167 # once after the Makefile is read. It is OK since we are going to invoke
169 MAKEFLAGS += --include-dir=$(CURDIR)
171 PHONY += $(MAKECMDGOALS) sub-make
173 $(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
177 $(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
178 -f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
180 # Leave processing to above invocation of make
182 endif # ifneq ($(KBUILD_OUTPUT),)
183 endif # ifeq ($(KBUILD_SRC),)
185 # We process the rest of the Makefile if this is the final invocation of make
186 ifeq ($(skip-makefile),)
188 # Do not print "Entering directory ...",
189 # but we want to display it when entering to the output directory
190 # so that IDEs/editors are able to understand relative filenames.
191 MAKEFLAGS += --no-print-directory
193 # Call a source code checker (by default, "sparse") as part of the
196 # Use 'make C=1' to enable checking of only re-compiled files.
197 # Use 'make C=2' to enable checking of *all* source files, regardless
198 # of whether they are re-compiled or not.
200 # See the file "doc/sparse.txt" for more details, including
201 # where to get the "sparse" utility.
203 ifeq ("$(origin C)", "command line")
204 KBUILD_CHECKSRC = $(C)
206 ifndef KBUILD_CHECKSRC
210 # Use make M=dir to specify directory of external module to build
211 # Old syntax make ... SUBDIRS=$PWD is still supported
212 # Setting the environment variable KBUILD_EXTMOD take precedence
214 KBUILD_EXTMOD ?= $(SUBDIRS)
217 ifeq ("$(origin M)", "command line")
218 KBUILD_EXTMOD := $(M)
221 # If building an external module we do not care about the all: rule
222 # but instead _all depend on modules
224 ifeq ($(KBUILD_EXTMOD),)
230 ifeq ($(KBUILD_SRC),)
231 # building in the source tree
234 ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
235 # building in a subdirectory of the source tree
238 srctree := $(KBUILD_SRC)
245 VPATH := $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))
247 export srctree objtree VPATH
249 # Make sure CDPATH settings don't interfere
252 #########################################################################
254 HOSTARCH := $(shell uname -m | \
256 -e s/sun4u/sparc64/ \
259 -e s/ppc64/powerpc/ \
261 -e s/macppc/powerpc/\
264 HOSTOS := $(shell uname -s | tr '[:upper:]' '[:lower:]' | \
265 sed -e 's/\(cygwin\).*/cygwin/')
267 export HOSTARCH HOSTOS
269 #########################################################################
271 # set default to nothing for native builds
272 ifeq ($(HOSTARCH),$(ARCH))
276 KCONFIG_CONFIG ?= .config
277 export KCONFIG_CONFIG
279 # SHELL used by kbuild
280 CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
281 else if [ -x /bin/bash ]; then echo /bin/bash; \
282 else echo sh; fi ; fi)
284 HOST_LFS_CFLAGS := $(shell getconf LFS_CFLAGS 2>/dev/null)
285 HOST_LFS_LDFLAGS := $(shell getconf LFS_LDFLAGS 2>/dev/null)
286 HOST_LFS_LIBS := $(shell getconf LFS_LIBS 2>/dev/null)
290 KBUILD_HOSTCFLAGS := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
291 $(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
292 KBUILD_HOSTCXXFLAGS := -O2 $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
293 KBUILD_HOSTLDFLAGS := $(HOST_LFS_LDFLAGS) $(HOSTLDFLAGS)
294 KBUILD_HOSTLDLIBS := $(HOST_LFS_LIBS) $(HOSTLDLIBS)
296 # With the move to GCC 6, we have implicitly upgraded our language
297 # standard to GNU11 (see https://gcc.gnu.org/gcc-5/porting_to.html).
298 # Some Linux distributions (including RHEL7, SLES13, Debian 8) still
299 # have older compilers as their default, so we make it explicit for
300 # these that our host tools are GNU11 (i.e. C11 w/ GNU extensions).
301 CSTD_FLAG := -std=gnu11
302 KBUILD_HOSTCFLAGS += $(CSTD_FLAG)
304 ifeq ($(HOSTOS),cygwin)
305 KBUILD_HOSTCFLAGS += -ansi
308 # Mac OS X / Darwin's C preprocessor is Apple specific. It
309 # generates numerous errors and warnings. We want to bypass it
310 # and use GNU C's cpp. To do this we pass the -traditional-cpp
311 # option to the compiler. Note that the -traditional-cpp flag
312 # DOES NOT have the same semantics as GNU C's flag, all it does
313 # is invoke the GNU preprocessor in stock ANSI/ISO C fashion.
315 # Apple's linker is similar, thanks to the new 2 stage linking
316 # multiple symbol definitions are treated as errors, hence the
317 # -multiply_defined suppress option to turn off this error.
319 ifeq ($(HOSTOS),darwin)
320 # get major and minor product version (e.g. '10' and '6' for Snow Leopard)
321 DARWIN_MAJOR_VERSION = $(shell sw_vers -productVersion | cut -f 1 -d '.')
322 DARWIN_MINOR_VERSION = $(shell sw_vers -productVersion | cut -f 2 -d '.')
324 os_x_before = $(shell if [ $(DARWIN_MAJOR_VERSION) -le $(1) -a \
325 $(DARWIN_MINOR_VERSION) -le $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
327 os_x_after = $(shell if [ $(DARWIN_MAJOR_VERSION) -ge $(1) -a \
328 $(DARWIN_MINOR_VERSION) -ge $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
330 # Snow Leopards build environment has no longer restrictions as described above
331 HOSTCC = $(call os_x_before, 10, 5, "cc", "gcc")
332 KBUILD_HOSTCFLAGS += $(call os_x_before, 10, 4, "-traditional-cpp")
333 KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 5, "-multiply_defined suppress")
335 # macOS Mojave (10.14.X)
336 # Undefined symbols for architecture x86_64: "_PyArg_ParseTuple"
337 KBUILD_HOSTLDFLAGS += $(call os_x_after, 10, 14, "-lpython -dynamclib", "")
340 # Decide whether to build built-in, modular, or both.
341 # Normally, just do built-in.
346 # If we have only "make modules", don't compile built-in objects.
347 # When we're building modules with modversions, we need to consider
348 # the built-in objects during the descend as well, in order to
349 # make sure the checksums are up to date before we record them.
351 ifeq ($(MAKECMDGOALS),modules)
352 KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
355 # If we have "make <whatever> modules", compile modules
356 # in addition to whatever we do anyway.
357 # Just "make" or "make all" shall build modules as well
359 # U-Boot does not need modules
360 #ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
361 # KBUILD_MODULES := 1
364 #ifeq ($(MAKECMDGOALS),)
365 # KBUILD_MODULES := 1
368 # Check ths size of a binary:
371 # #2: Size limit in bytes (decimal or 0xhex)
373 actual=$$( wc -c $1 | awk '{print $$1}'); \
374 limit=$$( printf "%d" $2 ); \
375 if test $$actual -gt $$limit; then \
376 echo "$1 exceeds file size limit:" >&2; \
377 echo " limit: $$(printf %#x $$limit) bytes" >&2; \
378 echo " actual: $$(printf %#x $$actual) bytes" >&2; \
379 echo " excess: $$(printf %#x $$((actual - limit))) bytes" >&2;\
385 export KBUILD_MODULES KBUILD_BUILTIN
386 export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD
388 # We need some generic definitions (do not try to remake the file).
389 scripts/Kbuild.include: ;
390 include scripts/Kbuild.include
392 # Make variables (CC, etc...)
394 AS = $(CROSS_COMPILE)as
396 ifneq ($(shell $(CROSS_COMPILE)ld.bfd -v 2> /dev/null),)
397 LD = $(CROSS_COMPILE)ld.bfd
399 LD = $(CROSS_COMPILE)ld
401 CC = $(CROSS_COMPILE)gcc
403 AR = $(CROSS_COMPILE)ar
404 NM = $(CROSS_COMPILE)nm
405 LDR = $(CROSS_COMPILE)ldr
406 STRIP = $(CROSS_COMPILE)strip
407 OBJCOPY = $(CROSS_COMPILE)objcopy
408 OBJDUMP = $(CROSS_COMPILE)objdump
417 # The devicetree compiler and pylibfdt are automatically built unless DTC is
418 # provided. If DTC is provided, it is assumed the pylibfdt is available too.
419 DTC_INTREE := $(objtree)/scripts/dtc/dtc
421 DTC_MIN_VERSION := 010406
425 CHECKFLAGS := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
426 -Wbitwise -Wno-return-void -D__CHECK_ENDIAN__ $(CF)
428 KBUILD_CPPFLAGS := -D__KERNEL__ -D__UBOOT__
430 KBUILD_CFLAGS := -Wall -Wstrict-prototypes \
431 -Wno-format-security \
432 -fno-builtin -ffreestanding $(CSTD_FLAG)
433 KBUILD_CFLAGS += -fshort-wchar -fno-strict-aliasing
434 KBUILD_AFLAGS := -D__ASSEMBLY__
437 ifeq ($(cc-name),clang)
438 ifneq ($(CROSS_COMPILE),)
439 CLANG_TARGET := --target=$(notdir $(CROSS_COMPILE:%-=%))
440 GCC_TOOLCHAIN_DIR := $(dir $(shell which $(LD)))
441 CLANG_PREFIX := --prefix=$(GCC_TOOLCHAIN_DIR)
442 GCC_TOOLCHAIN := $(realpath $(GCC_TOOLCHAIN_DIR)/..)
444 ifneq ($(GCC_TOOLCHAIN),)
445 CLANG_GCC_TC := --gcc-toolchain=$(GCC_TOOLCHAIN)
447 KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
448 KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
449 KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
450 KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
453 # Don't generate position independent code
454 KBUILD_CFLAGS += $(call cc-option,-fno-PIE)
455 KBUILD_AFLAGS += $(call cc-option,-fno-PIE)
457 # Read UBOOTRELEASE from include/config/uboot.release (if it exists)
458 UBOOTRELEASE = $(shell cat include/config/uboot.release 2> /dev/null)
459 UBOOTVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
461 export VERSION PATCHLEVEL SUBLEVEL UBOOTRELEASE UBOOTVERSION
462 export ARCH CPU BOARD VENDOR SOC CPUDIR BOARDDIR
463 export CONFIG_SHELL HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE AS LD CC
464 export CPP AR NM LDR STRIP OBJCOPY OBJDUMP KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS
465 export MAKE LEX YACC AWK PERL PYTHON PYTHON2 PYTHON3
466 export HOSTCXX KBUILD_HOSTCXXFLAGS CHECK CHECKFLAGS DTC DTC_FLAGS
468 export KBUILD_CPPFLAGS NOSTDINC_FLAGS UBOOTINCLUDE OBJCOPYFLAGS KBUILD_LDFLAGS
469 export KBUILD_CFLAGS KBUILD_AFLAGS
471 export CC_VERSION_TEXT := $(shell $(CC) --version | head -n 1)
473 # When compiling out-of-tree modules, put MODVERDIR in the module
474 # tree rather than in the kernel tree. The kernel tree might
476 export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions
478 # Files to ignore in find ... statements
480 export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o \
481 -name CVS -o -name .pc -o -name .hg -o -name .git \) \
483 export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
484 --exclude CVS --exclude .pc --exclude .hg --exclude .git
486 # ===========================================================================
487 # Rules shared between *config targets and build targets
489 # Basic helpers built in scripts/
490 PHONY += scripts_basic
492 $(Q)$(MAKE) $(build)=scripts/basic
493 $(Q)rm -f .tmp_quiet_recordmcount
495 # To avoid any implicit rule to kick in, define an empty command.
496 scripts/basic/%: scripts_basic ;
498 PHONY += outputmakefile
499 # outputmakefile generates a Makefile in the output directory, if using a
500 # separate output directory. This allows convenient use of make in the
503 ifneq ($(KBUILD_SRC),)
504 $(Q)ln -fsn $(srctree) source
505 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile $(srctree)
508 # To make sure we do not include .config for any of the *config targets
509 # catch them early, and hand them over to scripts/kconfig/Makefile
510 # It is allowed to specify more targets when calling make, including
511 # mixing *config targets and build targets.
512 # For example 'make oldconfig all'.
513 # Detect when mixed targets is specified, and make a second invocation
514 # of make so .config is not included in this case either (for *config).
516 version_h := include/generated/version_autogenerated.h
517 timestamp_h := include/generated/timestamp_autogenerated.h
518 defaultenv_h := include/generated/defaultenv_autogenerated.h
519 dt_h := include/generated/dt.h
520 env_h := include/generated/environment.h
522 no-dot-config-targets := clean clobber mrproper distclean \
523 help %docs check% coccicheck \
524 ubootversion backup tests check qcheck tcheck pylint \
531 ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
532 ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
537 ifeq ($(KBUILD_EXTMOD),)
538 ifneq ($(filter config %config,$(MAKECMDGOALS)),)
540 ifneq ($(words $(MAKECMDGOALS)),1)
546 ifeq ($(mixed-targets),1)
547 # ===========================================================================
548 # We're called with mixed targets (*config and build targets).
549 # Handle them one by one.
551 PHONY += $(MAKECMDGOALS) __build_one_by_one
553 $(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
558 for i in $(MAKECMDGOALS); do \
559 $(MAKE) -f $(srctree)/Makefile $$i; \
563 ifeq ($(config-targets),1)
564 # ===========================================================================
565 # *config targets only - make sure prerequisites are updated, and descend
566 # in scripts/kconfig to make the *config target
568 KBUILD_DEFCONFIG := sandbox_defconfig
569 export KBUILD_DEFCONFIG KBUILD_KCONFIG
571 config: scripts_basic outputmakefile FORCE
572 $(Q)$(MAKE) $(build)=scripts/kconfig $@
574 %config: scripts_basic outputmakefile FORCE
575 $(Q)$(MAKE) $(build)=scripts/kconfig $@
578 # ===========================================================================
579 # Build targets only - this includes vmlinux, arch specific targets, clean
580 # targets and others. In general all targets except *config targets.
582 # Additional helpers built in scripts/
583 # Carefully list dependencies so we do not try to build scripts twice
586 scripts: scripts_basic scripts_dtc include/config/auto.conf
587 $(Q)$(MAKE) $(build)=$(@)
589 ifeq ($(dot-config),1)
591 -include include/config/auto.conf
593 # Read in dependencies to all Kconfig* files, make sure to run
594 # oldconfig if changes are detected.
595 -include include/config/auto.conf.cmd
597 # To avoid any implicit rule to kick in, define an empty command
598 $(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;
600 # If .config is newer than include/config/auto.conf, someone tinkered
601 # with it and forgot to run make oldconfig.
602 # if auto.conf.cmd is missing then we are probably in a cleaned tree so
603 # we execute the config step to be sure to catch updated Kconfig files
604 include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
605 $(Q)$(MAKE) -f $(srctree)/Makefile syncconfig
606 @# If the following part fails, include/config/auto.conf should be
607 @# deleted so "make silentoldconfig" will be re-run on the next build.
608 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf || \
609 { rm -f include/config/auto.conf; false; }
610 @# include/config.h has been updated after "make silentoldconfig".
611 @# We need to touch include/config/auto.conf so it gets newer
612 @# than include/config.h.
613 @# Otherwise, 'make silentoldconfig' would be invoked twice.
614 $(Q)touch include/config/auto.conf
616 u-boot.cfg spl/u-boot.cfg tpl/u-boot.cfg:
617 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf $(@)
619 -include include/autoconf.mk
620 -include include/autoconf.mk.dep
622 # We want to include arch/$(ARCH)/config.mk only when include/config/auto.conf
623 # is up-to-date. When we switch to a different board configuration, old CONFIG
624 # macros are still remaining in include/config/auto.conf. Without the following
625 # gimmick, wrong config.mk would be included leading nasty warnings/errors.
626 ifneq ($(wildcard $(KCONFIG_CONFIG)),)
627 ifneq ($(wildcard include/config/auto.conf),)
628 autoconf_is_old := $(shell find . -path ./$(KCONFIG_CONFIG) -newer \
629 include/config/auto.conf)
630 ifeq ($(autoconf_is_old),)
632 include arch/$(ARCH)/Makefile
637 # These are set by the arch-specific config.mk. Make sure they are exported
638 # so they can be used when building an EFI application.
639 export EFI_LDS # Filename of EFI link script in arch/$(ARCH)/lib
640 export EFI_CRT0 # Filename of EFI CRT0 in arch/$(ARCH)/lib
641 export EFI_RELOC # Filename of EFU relocation code in arch/$(ARCH)/lib
642 export CFLAGS_EFI # Compiler flags to add when building EFI app
643 export CFLAGS_NON_EFI # Compiler flags to remove when building EFI app
644 export EFI_TARGET # binutils target if EFI is natively supported
646 # If board code explicitly specified LDSCRIPT or CONFIG_SYS_LDSCRIPT, use
647 # that (or fail if absent). Otherwise, search for a linker script in a
651 #LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds.debug
652 ifdef CONFIG_SYS_LDSCRIPT
653 # need to strip off double quotes
654 LDSCRIPT := $(srctree)/$(CONFIG_SYS_LDSCRIPT:"%"=%)
658 # If there is no specified link script, we look in a number of places for it
660 ifeq ($(wildcard $(LDSCRIPT)),)
661 LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds
663 ifeq ($(wildcard $(LDSCRIPT)),)
664 LDSCRIPT := $(srctree)/$(CPUDIR)/u-boot.lds
666 ifeq ($(wildcard $(LDSCRIPT)),)
667 LDSCRIPT := $(srctree)/arch/$(ARCH)/cpu/u-boot.lds
672 # Dummy target needed, because used as prerequisite
673 include/config/auto.conf: ;
674 endif # $(dot-config)
677 # Xtensa linker script cannot be preprocessed with -ansi because of
678 # preprocessor operations on strings that don't make C identifiers.
680 ifeq ($(CONFIG_XTENSA),)
684 ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
688 ifdef CONFIG_CC_OPTIMIZE_FOR_SPEED
692 ifdef CONFIG_CC_OPTIMIZE_FOR_DEBUG
698 export LTO_CFLAGS LTO_FINAL_LDFLAGS
700 ifeq ($(cc-name),clang)
702 LTO_FINAL_LDFLAGS += -flto
704 AR = $(shell $(CC) -print-prog-name=llvm-ar)
705 NM = $(shell $(CC) -print-prog-name=llvm-nm)
707 NPROC := $(shell nproc 2>/dev/null || echo 1)
708 LTO_CFLAGS += -flto=$(NPROC)
709 LTO_FINAL_LDFLAGS += -fuse-linker-plugin -flto=$(NPROC)
711 # use plugin aware tools
712 AR = $(CROSS_COMPILE)gcc-ar
713 NM = $(CROSS_COMPILE)gcc-nm
716 CFLAGS_NON_EFI += $(LTO_CFLAGS)
718 KBUILD_CFLAGS += $(LTO_CFLAGS)
721 ifeq ($(CONFIG_STACKPROTECTOR),y)
722 KBUILD_CFLAGS += $(call cc-option,-fstack-protector-strong)
723 CFLAGS_EFI += $(call cc-option,-fno-stack-protector)
725 KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
727 KBUILD_CFLAGS += $(call cc-option,-fno-delete-null-pointer-checks)
729 # disable pointer signed / unsigned warnings in gcc 4.0
730 KBUILD_CFLAGS += -Wno-pointer-sign
732 # disable stringop warnings in gcc 8+
733 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-truncation)
735 KBUILD_CFLAGS += $(call cc-disable-warning, zero-length-bounds)
736 KBUILD_CFLAGS += $(call cc-disable-warning, array-bounds)
737 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-overflow)
739 # Enabled with W=2, disabled by default as noisy
740 KBUILD_CFLAGS += $(call cc-disable-warning, maybe-uninitialized)
742 # change __FILE__ to the relative path from the srctree
743 KBUILD_CFLAGS += $(call cc-option,-fmacro-prefix-map=$(srctree)/=)
746 # $(KBUILD_AFLAGS) sets -g, which causes gcc to pass a suitable -g<format>
747 # option to the assembler.
750 # Report stack usage if supported
751 # ARC tools based on GCC 7.1 has an issue with stack usage
752 # with naked functions, see commit message for more details
754 ifeq ($(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-stack-usage.sh $(CC)),y)
755 KBUILD_CFLAGS += -fstack-usage
759 KBUILD_CFLAGS += $(call cc-option,-Wno-format-nonliteral)
760 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
762 ifdef CONFIG_CC_IS_CLANG
763 KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
764 KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
765 KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
766 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
767 # Quiet clang warning: comparison of unsigned expression < 0 is always false
768 KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
769 # CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
770 # source of a reference will be _MergedGlobals and not on of the whitelisted names.
771 # See modpost pattern 2
772 KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
773 KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
776 # These warnings generated too much noise in a regular build.
777 # Use make W=1 to enable them (see scripts/Makefile.extrawarn)
778 KBUILD_CFLAGS += $(call cc-disable-warning, unused-but-set-variable)
780 # Prohibit date/time macros, which would make the build non-deterministic
781 KBUILD_CFLAGS += $(call cc-option,-Werror=date-time)
783 include scripts/Makefile.extrawarn
785 # Add user supplied CPPFLAGS, AFLAGS and CFLAGS as the last assignments
786 KBUILD_CPPFLAGS += $(KCPPFLAGS)
787 KBUILD_AFLAGS += $(KAFLAGS)
788 KBUILD_CFLAGS += $(KCFLAGS)
790 KBUILD_HOSTCFLAGS += $(if $(CONFIG_TOOLS_DEBUG),-g)
792 # Use UBOOTINCLUDE when you must reference the include/ directory.
793 # Needed to be compatible with the O= option
796 $(if $(KBUILD_SRC), -I$(srctree)/include) \
797 $(if $(CONFIG_$(SPL_)SYS_THUMB_BUILD), \
798 $(if $(CONFIG_HAS_THUMB2), \
799 $(if $(CONFIG_CPU_V7M), \
800 -I$(srctree)/arch/arm/thumb1/include), \
801 -I$(srctree)/arch/arm/thumb1/include)) \
802 -I$(srctree)/arch/$(ARCH)/include \
803 -include $(srctree)/include/linux/kconfig.h
805 NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)
808 cpp_flags := $(KBUILD_CPPFLAGS) $(PLATFORM_CPPFLAGS) $(UBOOTINCLUDE) \
810 c_flags := $(KBUILD_CFLAGS) $(cpp_flags)
812 #########################################################################
813 # U-Boot objects....order is important (i.e. start must be first)
815 HAVE_VENDOR_COMMON_LIB = $(if $(wildcard $(srctree)/board/$(VENDOR)/common/Makefile),y,n)
817 libs-$(CONFIG_API) += api/
818 libs-$(HAVE_VENDOR_COMMON_LIB) += board/$(VENDOR)/common/
822 libs-$(CONFIG_OF_EMBED) += dts/
829 libs-$(CONFIG_SYS_FSL_DDR) += drivers/ddr/fsl/
830 libs-$(CONFIG_SYS_FSL_MMDC) += drivers/ddr/fsl/
831 libs-$(CONFIG_$(SPL_)ALTERA_SDRAM) += drivers/ddr/altera/
832 libs-y += drivers/usb/cdns3/
833 libs-y += drivers/usb/dwc3/
834 libs-y += drivers/usb/common/
835 libs-y += drivers/usb/emul/
836 libs-y += drivers/usb/eth/
837 libs-$(CONFIG_USB_DEVICE) += drivers/usb/gadget/
838 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/
839 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/udc/
840 libs-y += drivers/usb/host/
841 libs-y += drivers/usb/mtu3/
842 libs-y += drivers/usb/musb/
843 libs-y += drivers/usb/musb-new/
844 libs-y += drivers/usb/phy/
845 libs-y += drivers/usb/ulpi/
849 libs-$(CONFIG_UNIT_TEST) += test/
850 libs-$(CONFIG_UT_ENV) += test/env/
851 libs-$(CONFIG_UT_OPTEE) += test/optee/
852 libs-$(CONFIG_UT_OVERLAY) += test/overlay/
854 libs-y += $(if $(BOARDDIR),board/$(BOARDDIR)/)
856 libs-y := $(sort $(libs-y))
858 u-boot-dirs := $(patsubst %/,%,$(filter %/, $(libs-y))) tools examples
860 u-boot-alldirs := $(sort $(u-boot-dirs) $(patsubst %/,%,$(filter %/, $(libs-))))
862 libs-y := $(patsubst %/, %/built-in.o, $(libs-y))
864 u-boot-init := $(head-y)
865 u-boot-main := $(libs-y)
869 ifeq ($(CONFIG_USE_PRIVATE_LIBGCC),y)
870 PLATFORM_LIBGCC = arch/$(ARCH)/lib/lib.a
872 PLATFORM_LIBGCC := -L $(shell dirname `$(CC) $(c_flags) -print-libgcc-file-name`) -lgcc
874 PLATFORM_LIBS += $(PLATFORM_LIBGCC)
876 ifdef CONFIG_CC_COVERAGE
877 KBUILD_CFLAGS += --coverage
878 PLATFORM_LIBGCC += -lgcov
882 export PLATFORM_LIBGCC
884 # Special flags for CPP when processing the linker script.
885 # Pass the version down so we can handle backwards compatibility
888 -include $(srctree)/include/u-boot/u-boot.lds.h \
890 $(shell $(LD) --version | \
891 sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')
893 #########################################################################
894 #########################################################################
896 ifneq ($(CONFIG_BOARD_SIZE_LIMIT),)
897 BOARD_SIZE_CHECK= @ $(call size_check,$@,$(CONFIG_BOARD_SIZE_LIMIT))
902 ifneq ($(CONFIG_SPL_SIZE_LIMIT),0x0)
903 SPL_SIZE_CHECK = @$(call size_check,$@,$$(tools/spl_size_limit))
908 ifneq ($(CONFIG_TPL_SIZE_LIMIT),0x0)
909 TPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_TPL_SIZE_LIMIT))
914 # Statically apply RELA-style relocations (currently arm64 only)
915 # This is useful for arm64 where static relocation needs to be performed on
916 # the raw binary, but certain simulators only accept an ELF file (but don't
917 # do the relocation).
918 ifneq ($(CONFIG_STATIC_RELA),)
919 # $(1) is u-boot ELF, $(2) is u-boot bin, $(3) is text base
920 quiet_cmd_static_rela = RELOC $@
922 start=$$($(NM) $(2) | grep __rel_dyn_start | cut -f 1 -d ' '); \
923 end=$$($(NM) $(2) | grep __rel_dyn_end | cut -f 1 -d ' '); \
924 tools/relocate-rela $(3) $(4) $$start $$end
926 quiet_cmd_static_rela =
930 # Always append INPUTS so that arch config.mk's can add custom ones
931 INPUTS-y += u-boot.srec u-boot.bin u-boot.sym System.map binary_size_check
933 INPUTS-$(CONFIG_ONENAND_U_BOOT) += u-boot-onenand.bin
934 ifeq ($(CONFIG_SPL_FSL_PBL),y)
935 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot-with-spl-pbl.bin
937 ifneq ($(CONFIG_NXP_ESBC), y)
938 # For Secure Boot The Image needs to be signed and Header must also
939 # be included. So The image has to be built explicitly
940 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot.pbl
943 INPUTS-$(CONFIG_SPL) += spl/u-boot-spl.bin
944 ifeq ($(CONFIG_MX6)$(CONFIG_IMX_HAB), yy)
945 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
947 ifeq ($(CONFIG_MX7)$(CONFIG_IMX_HAB), yy)
948 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
950 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot.img
953 INPUTS-$(CONFIG_TPL) += tpl/u-boot-tpl.bin
955 # Allow omitting the .dtb output if it is not normally used
956 INPUTS-$(CONFIG_OF_SEPARATE) += $(if $(CONFIG_OF_OMIT_DTB),dts/dt.dtb,u-boot.dtb)
957 ifeq ($(CONFIG_SPL_FRAMEWORK),y)
958 INPUTS-$(CONFIG_OF_SEPARATE) += u-boot-dtb.img
960 INPUTS-$(CONFIG_SANDBOX) += u-boot.dtb
961 ifneq ($(CONFIG_SPL_TARGET),)
962 INPUTS-$(CONFIG_SPL) += $(CONFIG_SPL_TARGET:"%"=%)
964 INPUTS-$(CONFIG_REMAKE_ELF) += u-boot.elf
965 INPUTS-$(CONFIG_EFI_APP) += u-boot-app.efi
966 INPUTS-$(CONFIG_EFI_STUB) += u-boot-payload.efi
968 # Generate this input file for binman
969 ifeq ($(CONFIG_SPL),)
970 INPUTS-$(CONFIG_ARCH_MEDIATEK) += u-boot-mtk.bin
973 # Add optional build target if defined in board/cpu/soc headers
974 ifneq ($(CONFIG_BUILD_TARGET),)
975 INPUTS-y += $(CONFIG_BUILD_TARGET:"%"=%)
978 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
979 INPUTS-y += init_sp_bss_offset_check
982 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
983 INPUTS-y += u-boot-with-dtb.bin
986 ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
987 # On ARM64 this target is produced by binman so we don't need this dep
988 ifeq ($(CONFIG_ARM64),y)
989 ifeq ($(CONFIG_SPL),y)
990 # TODO: Get binman to generate this too
991 INPUTS-y += u-boot-rockchip.bin
994 ifeq ($(CONFIG_SPL),y)
995 # Generate these inputs for binman which will create the output files
996 INPUTS-y += idbloader.img u-boot.img
1001 INPUTS-$(CONFIG_X86) += u-boot-x86-start16.bin u-boot-x86-reset16.bin \
1002 $(if $(CONFIG_SPL_X86_16BIT_INIT),spl/u-boot-spl.bin) \
1003 $(if $(CONFIG_TPL_X86_16BIT_INIT),tpl/u-boot-tpl.bin)
1005 LDFLAGS_u-boot += $(LDFLAGS_FINAL)
1007 # Avoid 'Not enough room for program headers' error on binutils 2.28 onwards.
1008 LDFLAGS_u-boot += $(call ld-option, --no-dynamic-linker)
1011 LDFLAGS_u-boot += -z notext
1013 LDFLAGS_u-boot += --build-id=none
1015 ifeq ($(CONFIG_ARC)$(CONFIG_NIOS2)$(CONFIG_X86)$(CONFIG_XTENSA),)
1016 LDFLAGS_u-boot += -Ttext $(CONFIG_SYS_TEXT_BASE)
1019 # insure the checker run with the right endianness
1020 CHECKFLAGS += $(if $(CONFIG_CPU_BIG_ENDIAN),-mbig-endian,-mlittle-endian)
1022 # the checker needs the correct machine size
1023 CHECKFLAGS += $(if $(CONFIG_64BIT),-m64,-m32)
1025 # Normally we fill empty space with 0xff
1026 quiet_cmd_objcopy = OBJCOPY $@
1027 cmd_objcopy = $(OBJCOPY) --gap-fill=0xff $(OBJCOPYFLAGS) \
1028 $(OBJCOPYFLAGS_$(@F)) $< $@
1030 # Provide a version which does not do this, for use by EFI
1031 quiet_cmd_zobjcopy = OBJCOPY $@
1032 cmd_zobjcopy = $(OBJCOPY) $(OBJCOPYFLAGS) $(OBJCOPYFLAGS_$(@F)) $< $@
1034 quiet_cmd_efipayload = OBJCOPY $@
1035 cmd_efipayload = $(OBJCOPY) -I binary -O $(EFIPAYLOAD_BFDTARGET) -B $(EFIPAYLOAD_BFDARCH) $< $@
1037 MKIMAGEOUTPUT ?= /dev/null
1039 quiet_cmd_mkimage = MKIMAGE $@
1040 cmd_mkimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) -d $< $@ \
1041 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1043 quiet_cmd_mkfitimage = MKIMAGE $@
1044 cmd_mkfitimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) \
1045 -f $(U_BOOT_ITS) -p $(CONFIG_FIT_EXTERNAL_OFFSET) $@ \
1046 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1048 quiet_cmd_cat = CAT $@
1049 cmd_cat = cat $(filter-out $(PHONY), $^) > $@
1051 append = cat $(filter-out $< $(PHONY), $^) >> $@
1053 quiet_cmd_pad_cat = CAT $@
1054 cmd_pad_cat = $(cmd_objcopy) && $(append) || { rm -f $@; false; }
1056 quiet_cmd_lzma = LZMA $@
1057 cmd_lzma = lzma -c -z -k -9 $< > $@
1061 quiet_cmd_cfgcheck = CFGCHK $2
1062 cmd_cfgcheck = $(srctree)/scripts/check-config.sh $2 \
1063 $(srctree)/scripts/config_whitelist.txt $(srctree)
1065 quiet_cmd_ofcheck = OFCHK $2
1066 cmd_ofcheck = $(srctree)/scripts/check-of.sh $2 \
1067 $(srctree)/scripts/of_allowlist.txt
1069 # Concat the value of all the CONFIGs (result is 'y' or 'yy', etc. )
1070 got = $(foreach cfg,$(1),$($(cfg)))
1072 # expected value 'y for each one
1073 expect = $(foreach cfg,$(1),y)
1075 # Show a deprecation message
1077 # 1: List of CONFIG_DM_... to migrate to (e.g. "CONFIG_DM_MMC CONFIG_BLK")
1078 # 2: Name of component (e.g . "Ethernet drivers")
1079 # 3: Release deadline (e.g. "v202.07")
1080 # 4: Condition to require before checking (e.g. "$(CONFIG_NET)")
1081 # Note: Script avoids bash construct, hence the strange double 'if'
1082 # (patches welcome!)
1084 @if [ -n "$(strip $(4))" ]; then if [ "$(got)" != "$(expect)" ]; then \
1085 echo >&2 "===================== WARNING ======================"; \
1086 echo >&2 "This board does not use $(firstword $(1)) (Driver Model"; \
1087 echo >&2 "for $(2)). Please update the board to use"; \
1088 echo >&2 "$(firstword $(1)) before the $(3) release. Failure to"; \
1089 echo >&2 "update by the deadline may result in board removal."; \
1090 echo >&2 "See doc/driver-model/migration.rst for more info."; \
1091 echo >&2 "===================================================="; \
1099 all: .binman_stamp inputs
1100 ifeq ($(CONFIG_BINMAN),y)
1101 $(call if_changed,binman)
1104 # Timestamp file to make sure that binman always runs
1105 .binman_stamp: FORCE
1108 ifeq ($(CONFIG_DEPRECATED),y)
1109 $(warning "You have deprecated configuration options enabled in your .config! Please check your configuration.")
1111 ifeq ($(CONFIG_OF_EMBED)$(CONFIG_EFI_APP),y)
1112 @echo >&2 "===================== WARNING ======================"
1113 @echo >&2 "CONFIG_OF_EMBED is enabled. This option should only"
1114 @echo >&2 "be used for debugging purposes. Please use"
1115 @echo >&2 "CONFIG_OF_SEPARATE for boards in mainline."
1116 @echo >&2 "See doc/README.fdt-control for more info."
1117 @echo >&2 "===================================================="
1119 ifneq ($(CONFIG_SPL_FIT_GENERATOR),)
1120 @echo >&2 "===================== WARNING ======================"
1121 @echo >&2 "This board uses CONFIG_SPL_FIT_GENERATOR. Please migrate"
1122 @echo >&2 "to binman instead, to avoid the proliferation of"
1123 @echo >&2 "arch-specific scripts with no tests."
1124 @echo >&2 "===================================================="
1126 ifneq ($(CONFIG_DM),y)
1127 @echo >&2 "===================== WARNING ======================"
1128 @echo >&2 "This board does not use CONFIG_DM. CONFIG_DM will be"
1129 @echo >&2 "compulsory starting with the v2020.01 release."
1130 @echo >&2 "Failure to update may result in board removal."
1131 @echo >&2 "See doc/driver-model/migration.rst for more info."
1132 @echo >&2 "===================================================="
1134 $(call deprecated,CONFIG_WDT,DM watchdog,v2019.10,\
1135 $(CONFIG_WATCHDOG)$(CONFIG_HW_WATCHDOG))
1136 $(call deprecated,CONFIG_DM_ETH,Ethernet drivers,v2020.07,$(CONFIG_NET))
1137 $(call deprecated,CONFIG_DM_I2C,I2C drivers,v2022.04,$(CONFIG_SYS_I2C_LEGACY))
1138 $(call deprecated,CONFIG_DM_KEYBOARD,Keyboard drivers,v2022.10,$(CONFIG_KEYBOARD))
1139 @# CONFIG_SYS_TIMER_RATE has brackets in it for some boards which
1140 @# confuses this rule. Use if() to send just a single character which
1141 @# is enable to tell 'deprecated' that one of these symbols exists
1142 $(call deprecated,CONFIG_TIMER,Timer drivers,v2023.01,$(if $(strip $(CONFIG_SYS_TIMER_RATE)$(CONFIG_SYS_TIMER_COUNTER)),x))
1143 $(call deprecated,CONFIG_DM_SERIAL,Serial drivers,v2023.04,$(CONFIG_SERIAL))
1144 $(call deprecated,CONFIG_DM_SCSI,SCSI drivers,v2023.04,$(CONFIG_SCSI))
1145 @# Check that this build does not use CONFIG options that we do not
1146 @# know about unless they are in Kconfig. All the existing CONFIG
1147 @# options are whitelisted, so new ones should not be added.
1148 $(call cmd,cfgcheck,u-boot.cfg)
1149 @# Check that this build does not override OF_HAS_PRIOR_STAGE by
1150 @# disabling OF_BOARD.
1151 $(call cmd,ofcheck,$(KCONFIG_CONFIG))
1157 $(Q)$(MAKE) $(build)=dts dtbs
1159 quiet_cmd_copy = COPY $@
1162 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1164 ifeq ($(CONFIG_MULTI_DTB_FIT_LZO),y)
1165 FINAL_DTB_CONTAINER = fit-dtb.blob.lzo
1166 else ifeq ($(CONFIG_MULTI_DTB_FIT_GZIP),y)
1167 FINAL_DTB_CONTAINER = fit-dtb.blob.gz
1169 FINAL_DTB_CONTAINER = fit-dtb.blob
1172 fit-dtb.blob.gz: fit-dtb.blob
1175 fit-dtb.blob.lzo: fit-dtb.blob
1178 fit-dtb.blob: dts/dt.dtb FORCE
1179 $(call if_changed,mkimage)
1180 ifneq ($(SOURCE_DATE_EPOCH),)
1181 touch -d @$(SOURCE_DATE_EPOCH) fit-dtb.blob
1182 chmod 0600 fit-dtb.blob
1185 MKIMAGEFLAGS_fit-dtb.blob = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1187 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) -d /dev/null
1189 MKIMAGEFLAGS_fit-dtb.blob += -B 0x8
1192 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(EXT_DTB)
1193 $(call if_changed,cat)
1195 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(FINAL_DTB_CONTAINER)
1196 $(call if_changed,cat)
1199 u-boot.bin: u-boot-fit-dtb.bin FORCE
1200 $(call if_changed,copy)
1202 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1203 $(call if_changed,cat)
1205 else ifeq ($(CONFIG_OF_SEPARATE).$(CONFIG_OF_OMIT_DTB),y.)
1206 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1207 $(call if_changed,cat)
1209 u-boot.bin: u-boot-dtb.bin FORCE
1210 $(call if_changed,copy)
1212 u-boot.bin: u-boot-nodtb.bin FORCE
1213 $(call if_changed,copy)
1216 # we call Makefile in arch/arm/mach-imx which
1217 # has targets which are dependent on targets defined
1218 # here. make could not resolve them and we must ensure
1219 # that they are finished before calling imx targets
1220 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1221 IMX_DEPS = u-boot-fit-dtb.bin
1224 %.imx: $(IMX_DEPS) %.bin
1225 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1229 $(Q)$(MAKE) $(build)=arch/arm/cpu/armv7/vf610 $@
1231 quiet_cmd_copy = COPY $@
1234 u-boot.dtb: dts/dt.dtb
1237 OBJCOPYFLAGS_u-boot.hex := -O ihex
1239 OBJCOPYFLAGS_u-boot.srec := -O srec
1241 u-boot.hex u-boot.srec: u-boot FORCE
1242 $(call if_changed,objcopy)
1244 OBJCOPYFLAGS_u-boot-elf.srec := $(OBJCOPYFLAGS_u-boot.srec)
1246 u-boot-elf.srec: u-boot.elf FORCE
1247 $(call if_changed,objcopy)
1249 OBJCOPYFLAGS_u-boot-spl.srec = $(OBJCOPYFLAGS_u-boot.srec)
1251 spl/u-boot-spl.srec: spl/u-boot-spl FORCE
1252 $(call if_changed,objcopy)
1255 $(Q)$(MAKE) $(build)=arch/arm/mach-rmobile $@
1257 OBJCOPYFLAGS_u-boot-nodtb.bin := -O binary \
1258 $(if $(CONFIG_X86_16BIT_INIT),-R .start16 -R .resetvec) \
1259 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR),-R .bootpg -R .resetvec)
1261 binary_size_check: u-boot-nodtb.bin FORCE
1262 @file_size=$(shell wc -c u-boot-nodtb.bin | awk '{print $$1}') ; \
1263 map_size=$(shell cat u-boot.map | \
1264 awk '/_image_copy_start/ {start = $$1} /_image_binary_end/ {end = $$1} END {if (start != "" && end != "") print "ibase=16; " toupper(end) " - " toupper(start)}' \
1267 if [ "" != "$$map_size" ]; then \
1268 if test $$map_size -ne $$file_size; then \
1269 echo "u-boot.map shows a binary size of $$map_size" >&2 ; \
1270 echo " but u-boot-nodtb.bin shows $$file_size" >&2 ; \
1275 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
1276 ifneq ($(CONFIG_SYS_MALLOC_F_LEN),)
1277 subtract_sys_malloc_f_len = space=$$(($${space} - $(CONFIG_SYS_MALLOC_F_LEN)))
1279 subtract_sys_malloc_f_len = true
1281 # The 1/4 margin below is somewhat arbitrary. The likely initial SP usage is
1282 # so low that the DTB could probably use 90%+ of the available space, for
1283 # current values of CONFIG_SYS_INIT_SP_BSS_OFFSET at least. However, let's be
1284 # safe for now and tweak this later if space becomes tight.
1285 # A rejected alternative would be to check that some absolute minimum stack
1286 # space was available. However, since CONFIG_SYS_INIT_SP_BSS_OFFSET is
1287 # deliberately build-specific, to take account of build-to-build stack usage
1288 # differences due to different feature sets, there is no common absolute value
1290 init_sp_bss_offset_check: u-boot.dtb FORCE
1291 @dtb_size=$(shell wc -c u-boot.dtb | awk '{print $$1}') ; \
1292 space=$(CONFIG_SYS_INIT_SP_BSS_OFFSET) ; \
1293 $(subtract_sys_malloc_f_len) ; \
1294 quarter_space=$$(($${space} / 4)) ; \
1295 if [ $${dtb_size} -gt $${quarter_space} ]; then \
1296 echo "u-boot.dtb is larger than 1 quarter of " >&2 ; \
1297 echo "(CONFIG_SYS_INIT_SP_BSS_OFFSET - CONFIG_SYS_MALLOC_F_LEN)" >&2 ; \
1302 shell_cmd = { $(call echo-cmd,$(1)) $(cmd_$(1)); }
1304 quiet_cmd_objcopy_uboot = OBJCOPY $@
1305 ifdef cmd_static_rela
1306 cmd_objcopy_uboot = $(cmd_objcopy) && $(call shell_cmd,static_rela,$<,$@,$(CONFIG_SYS_TEXT_BASE)) || { rm -f $@; false; }
1308 cmd_objcopy_uboot = $(cmd_objcopy)
1311 u-boot-nodtb.bin: u-boot FORCE
1312 $(call if_changed,objcopy_uboot)
1317 $(LDR) -T $(CONFIG_CPU) -c $@ $< $(LDR_FLAGS)
1321 # ---------------------------------------------------------------------------
1322 # Use 'make BINMAN_DEBUG=1' to enable debugging
1323 # Use 'make BINMAN_VERBOSE=3' to set vebosity level
1324 default_dt := $(if $(DEVICE_TREE),$(DEVICE_TREE),$(CONFIG_DEFAULT_DEVICE_TREE))
1326 quiet_cmd_binman = BINMAN $@
1327 cmd_binman = $(srctree)/tools/binman/binman $(if $(BINMAN_DEBUG),-D) \
1328 $(foreach f,$(BINMAN_TOOLPATHS),--toolpath $(f)) \
1329 --toolpath $(objtree)/tools \
1330 $(if $(BINMAN_VERBOSE),-v$(BINMAN_VERBOSE)) \
1331 build -u -d u-boot.dtb -O . -m --allow-missing \
1333 -I . -I $(srctree) -I $(srctree)/board/$(BOARDDIR) \
1334 -I arch/$(ARCH)/dts -a of-list=$(CONFIG_OF_LIST) \
1335 $(foreach f,$(BINMAN_INDIRS),-I $(f)) \
1336 -a atf-bl31-path=${BL31} \
1337 -a tee-os-path=${TEE} \
1338 -a opensbi-path=${OPENSBI} \
1339 -a default-dt=$(default_dt) \
1340 -a scp-path=$(SCP) \
1341 -a spl-bss-pad=$(if $(CONFIG_SPL_SEPARATE_BSS),,1) \
1342 -a tpl-bss-pad=$(if $(CONFIG_TPL_SEPARATE_BSS),,1) \
1343 -a spl-dtb=$(CONFIG_SPL_OF_REAL) \
1344 -a tpl-dtb=$(CONFIG_TPL_OF_REAL) \
1347 OBJCOPYFLAGS_u-boot.ldr.hex := -I binary -O ihex
1349 OBJCOPYFLAGS_u-boot.ldr.srec := -I binary -O srec
1351 u-boot.ldr.hex u-boot.ldr.srec: u-boot.ldr FORCE
1352 $(call if_changed,objcopy)
1355 # U-Boot entry point, needed for booting of full-blown U-Boot
1356 # from the SPL U-Boot version.
1358 ifndef CONFIG_SYS_UBOOT_START
1359 CONFIG_SYS_UBOOT_START := $(CONFIG_SYS_TEXT_BASE)
1362 # Boards with more complex image requirements can provide an .its source file
1363 # or a generator script
1364 # NOTE: Please do not use this. We are migrating away from Makefile rules to use
1366 ifneq ($(CONFIG_SPL_FIT_SOURCE),"")
1367 U_BOOT_ITS := u-boot.its
1368 $(U_BOOT_ITS): $(subst ",,$(CONFIG_SPL_FIT_SOURCE))
1369 $(call if_changed,copy)
1371 ifneq ($(CONFIG_USE_SPL_FIT_GENERATOR),)
1372 U_BOOT_ITS := u-boot.its
1373 ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-rockchip/make_fit_atf.py")
1374 U_BOOT_ITS_DEPS += u-boot
1376 $(U_BOOT_ITS): $(U_BOOT_ITS_DEPS) FORCE
1377 $(srctree)/$(CONFIG_SPL_FIT_GENERATOR) \
1378 $(patsubst %,arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) > $@
1382 ifdef CONFIG_SPL_LOAD_FIT
1383 MKIMAGEFLAGS_u-boot.img = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1384 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1385 -p $(CONFIG_FIT_EXTERNAL_OFFSET) \
1386 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board" -E \
1387 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(DEVICE_TREE))) \
1388 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) \
1389 $(patsubst %,-b arch/$(ARCH)/dts/%.dtbo,$(subst ",,$(CONFIG_OF_OVERLAY_LIST)))
1391 MKIMAGEFLAGS_u-boot.img = -A $(ARCH) -T firmware -C none -O u-boot \
1392 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1393 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1394 MKIMAGEFLAGS_u-boot-ivt.img = -A $(ARCH) -T firmware_ivt -C none -O u-boot \
1395 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1396 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1397 u-boot-ivt.img: MKIMAGEOUTPUT = u-boot-ivt.img.log
1400 MKIMAGEFLAGS_u-boot-dtb.img = $(MKIMAGEFLAGS_u-boot.img)
1402 # Some boards have the kwbimage.cfg file written in advance, while some
1403 # other boards generate it on the fly during the build in the build tree.
1404 # Let's check if the file exists in the build tree first, otherwise we
1405 # fall back to use the one in the source tree.
1406 KWD_CONFIG_FILE = $(shell \
1407 if [ -f $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%) ]; then \
1408 echo -n $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1410 echo -n $(srctree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1413 MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
1414 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE)
1416 MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
1417 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1418 $(if $(KEYDIR),-k $(KEYDIR))
1420 MKIMAGEFLAGS_u-boot.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1421 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -A $(ARCH) -T pblimage
1423 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1424 UBOOT_BIN := u-boot-with-dtb.bin
1426 UBOOT_BIN := u-boot.bin
1429 MKIMAGEFLAGS_u-boot-lzma.img = -A $(ARCH) -T standalone -C lzma -O u-boot \
1430 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1431 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1433 u-boot.bin.lzma: u-boot.bin FORCE
1434 $(call if_changed,lzma)
1436 u-boot-lzma.img: u-boot.bin.lzma FORCE
1437 $(call if_changed,mkimage)
1439 u-boot-dtb.img u-boot.img u-boot.kwb u-boot.pbl u-boot-ivt.img: \
1440 $(if $(CONFIG_SPL_LOAD_FIT),u-boot-nodtb.bin \
1441 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1442 ,$(UBOOT_BIN)) FORCE
1443 $(call if_changed,mkimage)
1446 ifeq ($(CONFIG_SPL_LOAD_FIT_FULL),y)
1447 MKIMAGEFLAGS_u-boot.itb =
1449 MKIMAGEFLAGS_u-boot.itb = -E
1451 MKIMAGEFLAGS_u-boot.itb += -B 0x8
1454 u-boot.itb: u-boot-nodtb.bin \
1455 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1457 $(call if_changed,mkfitimage)
1461 u-boot-spl.kwb: u-boot.bin spl/u-boot-spl.bin FORCE
1462 $(call if_changed,mkimage)
1464 u-boot.sha1: u-boot.bin
1465 tools/ubsha1 u-boot.bin
1468 $(OBJDUMP) -d $< > $@
1470 ifneq ($(CONFIG_SPL_PAYLOAD),)
1471 SPL_PAYLOAD := $(CONFIG_SPL_PAYLOAD:"%"=%)
1473 SPL_PAYLOAD := u-boot.bin
1476 SPL_IMAGE := $(CONFIG_SPL_IMAGE:"%"=%)
1478 OBJCOPYFLAGS_u-boot-with-spl.bin = -I binary -O binary \
1479 --pad-to=$(CONFIG_SPL_PAD_TO)
1480 u-boot-with-spl.bin: $(SPL_IMAGE) $(SPL_PAYLOAD) FORCE
1481 $(call if_changed,pad_cat)
1483 ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
1486 ifeq ($(CONFIG_SPL)$(CONFIG_TPL),yy)
1487 MKIMAGEFLAGS_u-boot-tpl-rockchip.bin = -n $(CONFIG_SYS_SOC) -T rksd
1488 tpl/u-boot-tpl-rockchip.bin: tpl/u-boot-tpl.bin FORCE
1489 $(call if_changed,mkimage)
1490 idbloader.img: tpl/u-boot-tpl-rockchip.bin spl/u-boot-spl.bin FORCE
1491 $(call if_changed,cat)
1493 MKIMAGEFLAGS_idbloader.img = -n $(CONFIG_SYS_SOC) -T rksd
1494 idbloader.img: spl/u-boot-spl.bin FORCE
1495 $(call if_changed,mkimage)
1498 ifeq ($(CONFIG_ARM64),y)
1499 OBJCOPYFLAGS_u-boot-rockchip.bin = -I binary -O binary \
1500 --pad-to=$(CONFIG_SPL_PAD_TO) --gap-fill=0xff
1501 u-boot-rockchip.bin: idbloader.img u-boot.itb FORCE
1502 $(call if_changed,pad_cat)
1503 endif # CONFIG_ARM64
1505 endif # CONFIG_ARCH_ROCKCHIP
1507 ifeq ($(CONFIG_ARCH_LPC32XX)$(CONFIG_SPL),yy)
1508 MKIMAGEFLAGS_lpc32xx-spl.img = -T lpc32xximage -a $(CONFIG_SPL_TEXT_BASE)
1510 lpc32xx-spl.img: spl/u-boot-spl.bin FORCE
1511 $(call if_changed,mkimage)
1513 OBJCOPYFLAGS_lpc32xx-boot-0.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1515 lpc32xx-boot-0.bin: lpc32xx-spl.img FORCE
1516 $(call if_changed,objcopy)
1518 OBJCOPYFLAGS_lpc32xx-boot-1.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1520 lpc32xx-boot-1.bin: lpc32xx-spl.img FORCE
1521 $(call if_changed,objcopy)
1523 lpc32xx-full.bin: lpc32xx-boot-0.bin lpc32xx-boot-1.bin u-boot.img FORCE
1524 $(call if_changed,cat)
1528 OBJCOPYFLAGS_u-boot-with-tpl.bin = -I binary -O binary \
1529 --pad-to=$(CONFIG_TPL_PAD_TO)
1530 tpl/u-boot-with-tpl.bin: tpl/u-boot-tpl.bin u-boot.bin FORCE
1531 $(call if_changed,pad_cat)
1533 SPL: spl/u-boot-spl.bin FORCE
1534 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1536 ifeq ($(CONFIG_ARCH_IMX8M)$(CONFIG_ARCH_IMX8), y)
1537 ifeq ($(CONFIG_SPL_LOAD_IMX_CONTAINER), y)
1538 u-boot.cnt: u-boot.bin FORCE
1539 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1541 flash.bin: spl/u-boot-spl.bin u-boot.cnt FORCE
1542 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1544 ifeq ($(CONFIG_BINMAN),y)
1545 flash.bin: spl/u-boot-spl.bin $(INPUTS-y) FORCE
1546 $(call if_changed,binman)
1548 flash.bin: spl/u-boot-spl.bin u-boot.itb FORCE
1549 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1554 u-boot.uim: u-boot.bin FORCE
1555 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1557 u-boot-with-spl.imx u-boot-with-nand-spl.imx: SPL $(if $(CONFIG_OF_SEPARATE),u-boot.img,u-boot.uim) FORCE
1558 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1560 MKIMAGEFLAGS_u-boot.ubl = -n $(UBL_CONFIG) -T ublimage -e $(CONFIG_SYS_TEXT_BASE)
1562 u-boot.ubl: u-boot-with-spl.bin FORCE
1563 $(call if_changed,mkimage)
1565 MKIMAGEFLAGS_u-boot-spl.ais = -s -n $(if $(CONFIG_AIS_CONFIG_FILE), \
1566 $(srctree)/$(CONFIG_AIS_CONFIG_FILE:"%"=%),"/dev/null") \
1567 -T aisimage -e $(CONFIG_SPL_TEXT_BASE)
1568 spl/u-boot-spl.ais: spl/u-boot-spl.bin FORCE
1569 $(call if_changed,mkimage)
1571 OBJCOPYFLAGS_u-boot.ais = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1572 u-boot.ais: spl/u-boot-spl.ais u-boot.img FORCE
1573 $(call if_changed,pad_cat)
1575 u-boot-signed.sb: u-boot.bin spl/u-boot-spl.bin
1576 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot-signed.sb
1577 u-boot.sb: u-boot.bin spl/u-boot-spl.bin
1578 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot.sb
1580 MKIMAGEFLAGS_u-boot-spl.img = -A $(ARCH) -T firmware -C none \
1581 -a $(CONFIG_SPL_TEXT_BASE) -e $(CONFIG_SPL_TEXT_BASE) -n XLOADER
1582 spl/u-boot-spl.img: spl/u-boot-spl.bin FORCE
1583 $(call if_changed,mkimage)
1585 ifneq ($(CONFIG_ARCH_SOCFPGA),)
1586 quiet_cmd_gensplx4 = GENSPLX4 $@
1587 cmd_gensplx4 = $(OBJCOPY) -I binary -O binary --gap-fill=0x0 \
1588 --pad-to=$(CONFIG_SPL_PAD_TO) \
1589 spl/u-boot-spl.sfp spl/u-boot-spl.sfp && \
1590 cat spl/u-boot-spl.sfp spl/u-boot-spl.sfp \
1591 spl/u-boot-spl.sfp spl/u-boot-spl.sfp > $@ || { rm -f $@; false; }
1592 spl/u-boot-splx4.sfp: spl/u-boot-spl.sfp FORCE
1593 $(call if_changed,gensplx4)
1595 quiet_cmd_socboot = SOCBOOT $@
1596 cmd_socboot = cat spl/u-boot-splx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1597 u-boot-with-spl.sfp: spl/u-boot-splx4.sfp u-boot.img FORCE
1598 $(call if_changed,socboot)
1600 quiet_cmd_gensplpadx4 = GENSPLPADX4 $@
1601 cmd_gensplpadx4 = dd if=/dev/zero of=spl/u-boot-spl.pad bs=64 count=1024 ; \
1602 cat spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1603 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1604 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1605 spl/u-boot-spl.sfp spl/u-boot-spl.pad > $@ || \
1606 { rm -f $@ spl/u-boot-spl.pad; false; }
1607 u-boot-spl-padx4.sfp: spl/u-boot-spl.sfp FORCE
1608 $(call if_changed,gensplpadx4)
1610 quiet_cmd_socnandboot = SOCNANDBOOT $@
1611 cmd_socnandboot = cat u-boot-spl-padx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1612 u-boot-with-nand-spl.sfp: u-boot-spl-padx4.sfp u-boot.img FORCE
1613 $(call if_changed,socnandboot)
1617 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1618 u-boot-with-dtb.bin: u-boot.bin u-boot.dtb \
1619 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR), u-boot-br.bin) FORCE
1620 $(call if_changed,binman)
1622 ifeq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR),y)
1623 OBJCOPYFLAGS_u-boot-br.bin := -O binary -j .bootpg -j .resetvec
1624 u-boot-br.bin: u-boot FORCE
1625 $(call if_changed,objcopy)
1629 quiet_cmd_ldr = LD $@
1630 cmd_ldr = $(LD) $(LDFLAGS_$(@F)) \
1631 $(filter-out FORCE,$^) -o $@
1634 OBJCOPYFLAGS_u-boot-x86-start16.bin := -O binary -j .start16
1635 u-boot-x86-start16.bin: u-boot FORCE
1636 $(call if_changed,objcopy)
1638 OBJCOPYFLAGS_u-boot-x86-reset16.bin := -O binary -j .resetvec
1639 u-boot-x86-reset16.bin: u-boot FORCE
1640 $(call if_changed,objcopy)
1644 OBJCOPYFLAGS_u-boot-app.efi := $(OBJCOPYFLAGS_EFI)
1645 u-boot-app.efi: u-boot FORCE
1646 $(call if_changed,zobjcopy)
1648 u-boot.bin.o: u-boot.bin FORCE
1649 $(call if_changed,efipayload)
1651 u-boot-payload.lds: $(LDSCRIPT_EFI) FORCE
1652 $(call if_changed_dep,cpp_lds)
1654 # Rule to link the EFI payload which contains a stub and a U-Boot binary
1655 quiet_cmd_u-boot_payload ?= LD $@
1656 cmd_u-boot_payload ?= $(LD) $(LDFLAGS_EFI_PAYLOAD) -o $@ \
1657 -T u-boot-payload.lds arch/x86/cpu/call32.o \
1658 lib/efi/efi.o lib/efi/efi_stub.o u-boot.bin.o \
1659 $(addprefix arch/$(ARCH)/lib/,$(EFISTUB))
1661 u-boot-payload: u-boot.bin.o u-boot-payload.lds FORCE
1662 $(call if_changed,u-boot_payload)
1664 OBJCOPYFLAGS_u-boot-payload.efi := $(OBJCOPYFLAGS_EFI)
1665 u-boot-payload.efi: u-boot-payload FORCE
1666 $(call if_changed,zobjcopy)
1668 u-boot-img.bin: spl/u-boot-spl.bin u-boot.img FORCE
1669 $(call if_changed,cat)
1671 #Add a target to create boot binary having SPL binary in PBI format
1672 #concatenated with u-boot binary. It is need by PowerPC SoC having
1673 #internal SRAM <= 512KB.
1674 MKIMAGEFLAGS_u-boot-spl.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1675 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage \
1676 -A $(ARCH) -a $(CONFIG_SPL_TEXT_BASE)
1678 spl/u-boot-spl.pbl: spl/u-boot-spl.bin FORCE
1679 $(call if_changed,mkimage)
1682 UBOOT_BINLOAD := u-boot.img
1684 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1685 UBOOT_BINLOAD := u-boot-with-dtb.bin
1687 UBOOT_BINLOAD := u-boot.bin
1691 OBJCOPYFLAGS_u-boot-with-spl-pbl.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
1694 u-boot-with-spl-pbl.bin: spl/u-boot-spl.pbl $(UBOOT_BINLOAD) FORCE
1695 $(call if_changed,pad_cat)
1697 # PPC4xx needs the SPL at the end of the image, since the reset vector
1698 # is located at 0xfffffffc. So we can't use the "u-boot-img.bin" target
1699 # and need to introduce a new build target with the full blown U-Boot
1700 # at the start padded up to the start of the SPL image. And then concat
1701 # the SPL image to the end.
1703 OBJCOPYFLAGS_u-boot-img-spl-at-end.bin := -I binary -O binary \
1704 --pad-to=$(CONFIG_UBOOT_PAD_TO) --gap-fill=0xff
1705 u-boot-img-spl-at-end.bin: u-boot.img spl/u-boot-spl.bin FORCE
1706 $(call if_changed,pad_cat)
1708 quiet_cmd_u-boot-elf ?= LD $@
1709 cmd_u-boot-elf ?= $(LD) u-boot-elf.o -o $@ \
1710 -T u-boot-elf.lds --defsym=$(CONFIG_PLATFORM_ELFENTRY)=$(CONFIG_SYS_TEXT_BASE) \
1711 -Ttext=$(CONFIG_SYS_TEXT_BASE)
1712 u-boot.elf: u-boot.bin u-boot-elf.lds
1713 $(Q)$(OBJCOPY) -I binary $(PLATFORM_ELFFLAGS) $< u-boot-elf.o
1714 $(call if_changed,u-boot-elf)
1716 u-boot-elf.lds: arch/u-boot-elf.lds prepare FORCE
1717 $(call if_changed_dep,cpp_lds)
1719 # MediaTek's ARM-based u-boot needs a header to contains its load address
1720 # which is parsed by the BootROM.
1721 # If the SPL build is enabled, the header will be added to the spl binary,
1722 # and the spl binary and the u-boot.img will be combined into one file.
1723 # Otherwise the header will be added to the u-boot.bin directly.
1725 ifeq ($(CONFIG_SPL),y)
1726 spl/u-boot-spl-mtk.bin: spl/u-boot-spl
1728 u-boot-mtk.bin: u-boot-with-spl.bin
1729 $(call if_changed,copy)
1731 MKIMAGEFLAGS_u-boot-mtk.bin = -T mtk_image \
1732 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1733 -n "$(patsubst "%",%,$(CONFIG_MTK_BROM_HEADER_INFO))"
1735 u-boot-mtk.bin: u-boot.bin FORCE
1736 $(call if_changed,mkimage)
1739 quiet_cmd_endian_swap = SWAP $@
1740 cmd_endian_swap = $(srctree)/tools/endian-swap.py $< $@
1742 u-boot-swap.bin: u-boot.bin FORCE
1743 $(call if_changed,endian_swap)
1745 ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(ARCH)/Makefile.postlink)
1747 # Generate linker list symbols references to force compiler to not optimize
1748 # them away when compiling with LTO
1750 u-boot-keep-syms-lto := keep-syms-lto.o
1751 u-boot-keep-syms-lto_c := $(patsubst %.o,%.c,$(u-boot-keep-syms-lto))
1753 quiet_cmd_keep_syms_lto = KSL $@
1754 cmd_keep_syms_lto = \
1755 $(srctree)/scripts/gen_ll_addressable_symbols.sh $(NM) $^ > $@
1757 quiet_cmd_keep_syms_lto_cc = KSLCC $@
1758 cmd_keep_syms_lto_cc = \
1759 $(CC) $(filter-out $(LTO_CFLAGS),$(c_flags)) -c -o $@ $<
1761 $(u-boot-keep-syms-lto_c): $(u-boot-main)
1762 $(call if_changed,keep_syms_lto)
1763 $(u-boot-keep-syms-lto): $(u-boot-keep-syms-lto_c)
1764 $(call if_changed,keep_syms_lto_cc)
1766 u-boot-keep-syms-lto :=
1769 # Rule to link u-boot
1770 # May be overridden by arch/$(ARCH)/config.mk
1772 quiet_cmd_u-boot__ ?= LTO $@
1774 $(CC) -nostdlib -nostartfiles \
1775 $(LTO_FINAL_LDFLAGS) $(c_flags) \
1776 $(KBUILD_LDFLAGS:%=-Wl,%) $(LDFLAGS_u-boot:%=-Wl,%) -o $@ \
1777 -T u-boot.lds $(u-boot-init) \
1778 -Wl,--whole-archive \
1780 $(u-boot-keep-syms-lto) \
1782 -Wl,--no-whole-archive \
1783 -Wl,-Map,u-boot.map; \
1784 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1786 # Note: Linking efi-x86_app64 causes a segfault in the linker at present
1787 # when using x86_64-linux-gnu-ld.bfd
1788 # For now, disable --whole-archive which makes things link, although not
1790 quiet_cmd_u-boot__ ?= LD $@
1791 cmd_u-boot__ ?= $(LD) $(KBUILD_LDFLAGS) $(LDFLAGS_u-boot) -o $@ \
1792 -T u-boot.lds $(u-boot-init) \
1795 --no-whole-archive \
1796 $(PLATFORM_LIBS) -Map u-boot.map; \
1797 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1800 quiet_cmd_smap = GEN common/system_map.o
1802 smap=`$(call SYSTEM_MAP,u-boot) | \
1803 awk '$$2 ~ /[tTwW]/ {printf $$1 $$3 "\\\\000"}'` ; \
1804 $(CC) $(c_flags) -DSYSTEM_MAP="\"$${smap}\"" \
1805 -c $(srctree)/common/system_map.c -o common/system_map.o
1807 u-boot: $(u-boot-init) $(u-boot-main) $(u-boot-keep-syms-lto) u-boot.lds FORCE
1808 +$(call if_changed,u-boot__)
1809 ifeq ($(CONFIG_KALLSYMS),y)
1811 $(call cmd,u-boot__) common/system_map.o
1814 ifeq ($(CONFIG_RISCV),y)
1815 @tools/prelink-riscv $@ 0
1818 quiet_cmd_sym ?= SYM $@
1819 cmd_sym ?= $(OBJDUMP) -t $< > $@
1820 u-boot.sym: u-boot FORCE
1821 $(call if_changed,sym)
1823 # Environment processing
1824 # ---------------------------------------------------------------------------
1826 # Directory where we expect the .env file, if it exists
1827 ENV_DIR := $(srctree)/board/$(BOARDDIR)
1829 # Basename of .env file, stripping quotes
1830 ENV_SOURCE_FILE := $(CONFIG_ENV_SOURCE_FILE:"%"=%)
1832 # Filename of .env file
1833 ENV_FILE_CFG := $(ENV_DIR)/$(ENV_SOURCE_FILE).env
1835 # Default filename, if CONFIG_ENV_SOURCE_FILE is empty
1836 ENV_FILE_BOARD := $(ENV_DIR)/$(CONFIG_SYS_BOARD:"%"=%).env
1838 # Select between the CONFIG_ENV_SOURCE_FILE and the default one
1839 ENV_FILE := $(if $(ENV_SOURCE_FILE),$(ENV_FILE_CFG),$(wildcard $(ENV_FILE_BOARD)))
1841 # Run the environment text file through the preprocessor, but only if it is
1842 # non-empty, to save time and possible build errors if something is wonky with
1844 quiet_cmd_gen_envp = ENVP $@
1846 if [ -s "$(ENV_FILE)" ]; then \
1847 $(CPP) -P $(CFLAGS) -x assembler-with-cpp -D__ASSEMBLY__ \
1848 -D__UBOOT_CONFIG__ \
1849 -I . -I include -I $(srctree)/include \
1850 -include linux/kconfig.h -include include/config.h \
1851 -I$(srctree)/arch/$(ARCH)/include \
1856 include/generated/env.in: include/generated/env.txt FORCE
1857 $(call cmd,gen_envp)
1859 # Regenerate the environment if it changes
1860 # We use 'wildcard' since the file is not required to exist (at present), in
1861 # which case we don't want this dependency, but instead should create an empty
1863 # This rule is useful since it shows the source file for the environment
1864 quiet_cmd_envc = ENVC $@
1866 if [ -f "$<" ]; then \
1868 elif [ -n "$(ENV_SOURCE_FILE)" ]; then \
1869 echo "Missing file $(ENV_FILE_CFG)"; \
1874 include/generated/env.txt: $(wildcard $(ENV_FILE)) FORCE
1877 # Write out the resulting environment, converted to a C string
1878 quiet_cmd_gen_envt = ENVT $@
1880 awk -f $(srctree)/scripts/env2string.awk $< >$@
1881 $(env_h): include/generated/env.in
1882 $(call cmd,gen_envt)
1884 # ---------------------------------------------------------------------------
1886 # The actual objects are generated when descending,
1887 # make sure no implicit rule kicks in
1888 $(sort $(u-boot-init) $(u-boot-main)): $(u-boot-dirs) ;
1890 # Handle descending into subdirectories listed in $(u-boot-dirs)
1891 # Preset locale variables to speed up the build process. Limit locale
1892 # tweaks to this spot to avoid wrong language settings when running
1893 # make menuconfig etc.
1894 # Error messages still appears in the original language
1896 PHONY += $(u-boot-dirs)
1897 $(u-boot-dirs): prepare scripts
1898 $(Q)$(MAKE) $(build)=$@
1901 # The "tools" are needed early
1902 $(filter-out tools, $(u-boot-dirs)): tools
1903 # The "examples" conditionally depend on U-Boot (say, when USE_PRIVATE_LIBGCC
1904 # is "yes"), so compile examples after U-Boot is compiled.
1905 examples: $(filter-out examples, $(u-boot-dirs))
1907 define filechk_uboot.release
1908 echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
1911 # Store (new) UBOOTRELEASE string in include/config/uboot.release
1912 include/config/uboot.release: include/config/auto.conf FORCE
1913 $(call filechk,uboot.release)
1916 # Things we need to do before we recursively start building the kernel
1917 # or the modules are listed in "prepare".
1918 # A multi level approach is used. prepareN is processed before prepareN-1.
1919 # archprepare is used in arch Makefiles and when processed asm symlink,
1920 # version.h and scripts_basic is processed / created.
1922 # Listed in dependency order
1923 PHONY += prepare archprepare prepare0 prepare1 prepare2 prepare3
1925 # prepare3 is used to check if we are building in a separate output directory,
1927 # 1) Check that make has not been executed in the kernel src $(srctree)
1928 prepare3: include/config/uboot.release
1929 ifneq ($(KBUILD_SRC),)
1930 @$(kecho) ' Using $(srctree) as source for U-Boot'
1931 $(Q)if [ -f $(srctree)/.config -o -d $(srctree)/include/config ]; then \
1932 echo >&2 " $(srctree) is not clean, please run 'make mrproper'"; \
1933 echo >&2 " in the '$(srctree)' directory.";\
1938 # prepare2 creates a makefile if using a separate output directory
1939 prepare2: prepare3 outputmakefile cfg
1941 prepare1: prepare2 $(version_h) $(timestamp_h) $(dt_h) $(env_h) \
1942 include/config/auto.conf
1943 ifeq ($(wildcard $(LDSCRIPT)),)
1944 @echo >&2 " Could not find linker script."
1948 ifeq ($(CONFIG_USE_DEFAULT_ENV_FILE),y)
1949 prepare1: $(defaultenv_h)
1951 envtools: $(defaultenv_h)
1954 archprepare: prepare1 scripts_basic
1956 prepare0: archprepare FORCE
1957 $(Q)$(MAKE) $(build)=.
1959 # All the preparing..
1962 # Generate some files
1963 # ---------------------------------------------------------------------------
1965 # Use sed to remove leading zeros from PATCHLEVEL to avoid using octal numbers
1966 define filechk_version.h
1967 (echo \#define PLAIN_VERSION \"$(UBOOTRELEASE)\"; \
1968 echo \#define U_BOOT_VERSION \"U-Boot \" PLAIN_VERSION; \
1969 echo \#define U_BOOT_VERSION_NUM $(VERSION); \
1970 echo \#define U_BOOT_VERSION_NUM_PATCH $$(echo $(PATCHLEVEL) | \
1971 sed -e "s/^0*//"); \
1972 echo \#define CC_VERSION_STRING \"$$(LC_ALL=C $(CC) --version | head -n 1)\"; \
1973 echo \#define LD_VERSION_STRING \"$$(LC_ALL=C $(LD) --version | head -n 1)\"; )
1976 # The SOURCE_DATE_EPOCH mechanism requires a date that behaves like GNU date.
1977 # The BSD date on the other hand behaves different and would produce errors
1978 # with the misused '-d' switch. Respect that and search a working date with
1979 # well known pre- and suffixes for the GNU variant of date.
1980 define filechk_timestamp.h
1981 (if test -n "$${SOURCE_DATE_EPOCH}"; then \
1982 SOURCE_DATE="@$${SOURCE_DATE_EPOCH}"; \
1984 for date in gdate date.gnu date; do \
1985 $${date} -u -d "$${SOURCE_DATE}" >/dev/null 2>&1 && DATE="$${date}"; \
1987 if test -n "$${DATE}"; then \
1988 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DATE "%b %d %C%y"'; \
1989 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TIME "%T"'; \
1990 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TZ "%z"'; \
1991 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_EPOCH %s'; \
1996 LC_ALL=C date +'#define U_BOOT_DATE "%b %d %C%y"'; \
1997 LC_ALL=C date +'#define U_BOOT_TIME "%T"'; \
1998 LC_ALL=C date +'#define U_BOOT_TZ "%z"'; \
1999 LC_ALL=C date +'#define U_BOOT_EPOCH %s'; \
2003 define filechk_defaultenv.h
2004 ( { grep -v '^#' | grep -v '^$$' || true ; echo '' ; } | \
2006 sed -e 's/\\\x0\s*//g' | \
2011 (if test -n "$${DEVICE_TREE}"; then \
2012 echo \#define DEVICE_TREE \"$(DEVICE_TREE)\"; \
2014 echo \#define DEVICE_TREE CONFIG_DEFAULT_DEVICE_TREE; \
2018 $(version_h): include/config/uboot.release FORCE
2019 $(call filechk,version.h)
2021 $(timestamp_h): $(srctree)/Makefile FORCE
2022 $(call filechk,timestamp.h)
2024 $(dt_h): $(srctree)/Makefile FORCE
2025 $(call filechk,dt.h)
2027 $(defaultenv_h): $(CONFIG_DEFAULT_ENV_FILE:"%"=%) FORCE
2028 $(call filechk,defaultenv.h)
2030 # ---------------------------------------------------------------------------
2033 ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/boot/dts/),)
2034 dtstree := arch/$(SRCARCH)/boot/dts
2039 %.dtb: prepare3 scripts_dtc
2040 $(Q)$(MAKE) $(build)=$(dtstree) $(dtstree)/$@
2042 PHONY += dtbs dtbs_install
2043 dtbs: prepare3 scripts_dtc
2044 $(Q)$(MAKE) $(build)=$(dtstree)
2047 $(Q)$(MAKE) $(dtbinst)=$(dtstree)
2049 ifdef CONFIG_OF_EARLY_FLATTREE
2055 # Check dtc and pylibfdt, if DTC is provided, else build them
2056 PHONY += scripts_dtc
2057 scripts_dtc: scripts_basic
2058 $(Q)if test "$(DTC)" = "$(DTC_INTREE)"; then \
2059 $(MAKE) $(build)=scripts/dtc; \
2061 if ! $(DTC) -v >/dev/null; then \
2062 echo '*** Failed to check dtc version: $(DTC)'; \
2065 if test "$(call dtc-version)" -lt $(DTC_MIN_VERSION); then \
2066 echo '*** Your dtc is too old, please upgrade to dtc $(DTC_MIN_VERSION) or newer'; \
2069 if [ -n "$(CONFIG_PYLIBFDT)" ]; then \
2070 if ! echo "import libfdt" | $(PYTHON3) 2>/dev/null; then \
2071 echo '*** pylibfdt does not seem to be available with $(PYTHON3)'; \
2079 # ---------------------------------------------------------------------------
2080 quiet_cmd_cpp_lds = LDS $@
2081 cmd_cpp_lds = $(CPP) -Wp,-MD,$(depfile) $(cpp_flags) $(LDPPFLAGS) \
2082 -D__ASSEMBLY__ -x assembler-with-cpp -std=c99 -P -o $@ $<
2084 u-boot.lds: $(LDSCRIPT) prepare FORCE
2085 $(call if_changed_dep,cpp_lds)
2087 spl/u-boot-spl.bin: spl/u-boot-spl
2091 spl/u-boot-spl-dtb.bin: spl/u-boot-spl
2094 spl/u-boot-spl-dtb.hex: spl/u-boot-spl
2097 spl/u-boot-spl: tools prepare \
2098 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb) \
2099 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_TPL_OF_PLATDATA),dts/dt.dtb)
2100 $(Q)$(MAKE) obj=spl -f $(srctree)/scripts/Makefile.spl all
2102 spl/sunxi-spl.bin: spl/u-boot-spl
2105 spl/sunxi-spl-with-ecc.bin: spl/sunxi-spl.bin
2108 spl/u-boot-spl.sfp: spl/u-boot-spl
2111 spl/boot.bin: spl/u-boot-spl
2114 tpl/u-boot-tpl.bin: tools prepare \
2115 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb)
2116 $(Q)$(MAKE) obj=tpl -f $(srctree)/scripts/Makefile.spl all
2119 TAG_SUBDIRS := $(patsubst %,$(srctree)/%,$(u-boot-dirs) include)
2125 ctags -w -o ctags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2126 -name '*.[chS]' -print`
2130 etags -a -o etags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2131 -name '*.[chS]' -print`
2133 $(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) -name '*.[chS]' -print > \
2135 @find $(TAG_SUBDIRS) -name '*.[chS]' -type l -print | \
2136 grep -xvf - cscope.files > cscope.files.no-symlinks; \
2137 mv cscope.files.no-symlinks cscope.files
2142 grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
2145 @$(call SYSTEM_MAP,$<) > $@
2147 #########################################################################
2149 # ARM relocations should all be R_ARM_RELATIVE (32-bit) or
2150 # R_AARCH64_RELATIVE (64-bit).
2151 checkarmreloc: u-boot
2152 @RELOC="`$(CROSS_COMPILE)readelf -r -W $< | cut -d ' ' -f 4 | \
2153 grep R_A | sort -u`"; \
2154 if test "$$RELOC" != "R_ARM_RELATIVE" -a \
2155 "$$RELOC" != "R_AARCH64_RELATIVE"; then \
2156 echo "$< contains unexpected relocations: $$RELOC"; \
2160 tools/version.h: include/version.h
2161 $(Q)mkdir -p $(dir $@)
2162 $(call if_changed,copy)
2164 envtools: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2165 $(Q)$(MAKE) $(build)=tools/env
2167 tools-only: export TOOLS_ONLY=y
2168 tools-only: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2169 $(Q)$(MAKE) $(build)=tools
2171 tools-all: export HOST_TOOLS_ALL=y
2172 tools-all: envtools tools ;
2174 cross_tools: export CROSS_BUILD_TOOLS=y
2175 cross_tools: tools ;
2179 git log --no-merges U-Boot-1_1_5.. | \
2180 unexpand -a | sed -e 's/\s\s*$$//' > $@
2182 #########################################################################
2185 # Cleaning is done on three levels.
2186 # make clean Delete most generated files
2187 # Leave enough to build external modules
2188 # make mrproper Delete the current configuration, and all generated files
2189 # make distclean Remove editor backup files, patch leftover files and the like
2191 # Directories & files removed with 'make clean'
2192 CLEAN_DIRS += $(MODVERDIR) \
2193 $(foreach d, spl tpl, $(patsubst %,$d/%, \
2194 $(filter-out include, $(shell ls -1 $d 2>/dev/null))))
2196 CLEAN_FILES += include/bmp_logo.h include/bmp_logo_data.h tools/version.h \
2197 u-boot* MLO* SPL System.map fit-dtb.blob* \
2198 u-boot-ivt.img.log u-boot-dtb.imx.log SPL.log u-boot.imx.log \
2199 lpc32xx-* bl31.c bl31.elf bl31_*.bin image.map tispl.bin* \
2200 idbloader.img flash.bin flash.log defconfig keep-syms-lto.c \
2201 mkimage-out.spl.mkimage mkimage.spl.mkimage imx-boot.map \
2202 itb.fit.fit itb.fit.itb itb.map spl.map
2204 # Directories & files removed with 'make mrproper'
2205 MRPROPER_DIRS += include/config include/generated spl tpl \
2206 .tmp_objdiff doc/output include/asm
2208 # Remove include/asm symlink created by U-Boot before v2014.01
2209 MRPROPER_FILES += .config .config.old include/autoconf.mk* include/config.h \
2210 ctags etags tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
2211 drivers/video/fonts/*.S include/asm
2213 # clean - Delete most, but leave enough to build external modules
2215 clean: rm-dirs := $(CLEAN_DIRS)
2216 clean: rm-files := $(CLEAN_FILES)
2218 clean-dirs := $(foreach f,$(u-boot-alldirs),$(if $(wildcard $(srctree)/$f/Makefile),$f))
2220 clean-dirs := $(addprefix _clean_, $(clean-dirs))
2222 PHONY += $(clean-dirs) clean archclean
2224 $(Q)$(MAKE) $(clean)=$(patsubst _clean_%,%,$@)
2226 clean: $(clean-dirs)
2229 @find $(if $(KBUILD_EXTMOD), $(KBUILD_EXTMOD), .) $(RCS_FIND_IGNORE) \
2230 \( -name '*.[oas]' -o -name '*.ko' -o -name '.*.cmd' \
2231 -o -name '*.ko.*' -o -name '*.su' -o -name '*.pyc' \
2232 -o -name '.*.d' -o -name '.*.tmp' -o -name '*.mod.c' \
2233 -o -name '*.lex.c' -o -name '*.tab.[ch]' \
2234 -o -name '*.asn1.[ch]' \
2235 -o -name '*.symtypes' -o -name 'modules.order' \
2236 -o -name modules.builtin -o -name '.tmp_*.o.*' \
2237 -o -name 'dsdt_generated.aml' -o -name 'dsdt_generated.asl.tmp' \
2238 -o -name 'dsdt_generated.c' \
2239 -o -name '*.efi' -o -name '*.gcno' -o -name '*.so' \) \
2240 -type f -print | xargs rm -f
2242 # mrproper - Delete all generated files, including .config
2244 mrproper: rm-dirs := $(wildcard $(MRPROPER_DIRS))
2245 mrproper: rm-files := $(wildcard $(MRPROPER_FILES))
2246 mrproper-dirs := $(addprefix _mrproper_,scripts)
2248 PHONY += $(mrproper-dirs) mrproper archmrproper
2250 $(Q)$(MAKE) $(clean)=$(patsubst _mrproper_%,%,$@)
2252 mrproper: clean $(mrproper-dirs)
2255 @rm -f arch/*/include/asm/arch
2262 @find $(srctree) $(RCS_FIND_IGNORE) \
2263 \( -name '*.orig' -o -name '*.rej' -o -name '*~' \
2264 -o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
2265 -o -name '.*.rej' -o -name '*%' -o -name 'core' \
2266 -o -name '*.pyc' \) \
2267 -type f -print | xargs rm -f
2268 @rm -f boards.cfg CHANGELOG
2270 # See doc/develop/python_cq.rst
2271 PHONY += pylint pylint_err
2272 PYLINT_BASE := scripts/pylint.base
2273 PYLINT_CUR := pylint.cur
2274 PYLINT_DIFF := pylint.diff
2276 $(Q)echo "Running pylint on all files (summary in $(PYLINT_CUR); output in pylint.out/)"
2277 $(Q)mkdir -p pylint.out
2278 $(Q)rm -f pylint.out/out*
2279 $(Q)find tools test -name "*.py" \
2280 | xargs -n1 -P$(shell nproc 2>/dev/null || echo 1) \
2281 sh -c 'pylint --reports=y --exit-zero -f parseable --ignore-imports=yes $$@ > pylint.out/$$(echo $$@ | tr / _ | sed s/.py//)' _
2282 $(Q)rm -f $(PYLINT_CUR)
2283 $(Q)( cd pylint.out; for f in *; do \
2284 sed -ne "s/Your code has been rated at \([-0-9.]*\).*/$$f \1/p" $$f; \
2285 done ) | sort > $(PYLINT_CUR)
2286 $(Q)base=$$(mktemp) cur=$$(mktemp); cut -d' ' -f1 $(PYLINT_BASE) >$$base; \
2287 cut -d' ' -f1 $(PYLINT_CUR) >$$cur; \
2288 comm -3 $$base $$cur > $(PYLINT_DIFF); \
2289 if [ -s $(PYLINT_DIFF) ]; then \
2290 echo "Files have been added/removed. Try:\n\tcp $(PYLINT_CUR) $(PYLINT_BASE)"; \
2292 echo "Added files:"; \
2293 comm -13 $$base $$cur; \
2295 echo "Removed files:"; \
2296 comm -23 $$base $$cur; \
2299 rm $$base $$cur $(PYLINT_DIFF); \
2301 $(Q)bad=false; while read base_file base_val <&3 && read cur_file cur_val <&4; do \
2302 if awk "BEGIN {exit !($$cur_val < $$base_val)}"; then \
2303 echo "$$base_file: Score was $$base_val, now $$cur_val"; \
2305 done 3<$(PYLINT_BASE) 4<$(PYLINT_CUR); \
2307 echo "Some files have regressed, please fix"; \
2310 echo "No pylint regressions"; \
2313 # Check for errors only
2315 $(Q)pylint -E -j 0 --ignore-imports=yes \
2316 $(shell find tools test -name "*.py")
2319 F=`basename $(srctree)` ; cd .. ; \
2320 gtar --force-local -zcvf `LC_ALL=C date "+$$F-%Y-%m-%d-%T.tar.gz"` $$F
2323 @echo 'Cleaning targets:'
2324 @echo ' clean - Remove most generated files but keep the config'
2325 @echo ' mrproper - Remove all generated files + config + various backup files'
2326 @echo ' distclean - mrproper + remove editor backup and patch files'
2328 @echo 'Configuration targets:'
2329 @$(MAKE) -f $(srctree)/scripts/kconfig/Makefile help
2331 @echo 'Test targets:'
2333 @echo ' check - Run all automated tests that use sandbox'
2334 @echo ' qcheck - Run quick automated tests that use sandbox'
2335 @echo ' tcheck - Run quick automated tests on tools'
2336 @echo ' pylint - Run pylint on all Python files'
2338 @echo 'Other generic targets:'
2339 @echo ' all - Build all necessary images depending on configuration'
2340 @echo ' tests - Build U-Boot for sandbox and run tests'
2341 @echo '* u-boot - Build the bare u-boot'
2342 @echo ' dir/ - Build all files in dir and below'
2343 @echo ' dir/file.[oisS] - Build specified target only'
2344 @echo ' dir/file.lst - Build specified mixed source/assembly target only'
2345 @echo ' (requires a recent binutils and recent build (System.map))'
2346 @echo ' tags/ctags - Generate ctags file for editors'
2347 @echo ' etags - Generate etags file for editors'
2348 @echo ' cscope - Generate cscope index'
2349 @echo ' ubootrelease - Output the release version string (use with make -s)'
2350 @echo ' ubootversion - Output the version stored in Makefile (use with make -s)'
2351 @echo " cfg - Don't build, just create the .cfg files"
2352 @echo " envtools - Build only the target-side environment tools"
2354 @echo 'Static analysers'
2355 @echo ' checkstack - Generate a list of stack hogs'
2356 @echo ' coccicheck - Execute static code analysis with Coccinelle'
2358 @echo 'Documentation targets:'
2359 @$(MAKE) -f $(srctree)/doc/Makefile dochelp
2361 @echo ' make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
2362 @echo ' make V=2 [targets] 2 => give reason for rebuild of target'
2363 @echo ' make O=dir [targets] Locate all output files in "dir", including .config'
2364 @echo ' make C=1 [targets] Check all c source with $$CHECK (sparse by default)'
2365 @echo ' make C=2 [targets] Force check of all c source with $$CHECK'
2366 @echo ' make RECORDMCOUNT_WARN=1 [targets] Warn about ignored mcount sections'
2367 @echo ' make W=n [targets] Enable extra gcc checks, n=1,2,3 where'
2368 @echo ' 1: warnings which may be relevant and do not occur too often'
2369 @echo ' 2: warnings which occur quite often but may still be relevant'
2370 @echo ' 3: more obscure warnings, can most likely be ignored'
2371 @echo ' Multiple levels can be combined with W=12 or W=123'
2373 @echo 'Execute "make" or "make all" to build all targets marked with [*] '
2374 @echo 'For further info see the ./README file'
2380 $(srctree)/test/run quick
2383 $(srctree)/test/run tools
2385 # Documentation targets
2386 # ---------------------------------------------------------------------------
2387 DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
2388 linkcheckdocs dochelp refcheckdocs
2389 PHONY += $(DOC_TARGETS)
2390 $(DOC_TARGETS): scripts_basic FORCE
2391 $(Q)$(MAKE) $(build)=doc $@
2393 PHONY += checkstack ubootrelease ubootversion
2396 $(OBJDUMP) -d u-boot $$(find . -name u-boot-spl) | \
2397 $(PERL) $(src)/scripts/checkstack.pl $(ARCH)
2400 @echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
2403 @echo $(UBOOTVERSION)
2406 # ---------------------------------------------------------------------------
2407 # Single targets are compatible with:
2408 # - build with mixed source and output
2409 # - build with separate output dir 'make O=...'
2410 # - external modules
2412 # target-dir => where to store outputfile
2413 # build-dir => directory in kernel source tree to use
2415 ifeq ($(KBUILD_EXTMOD),)
2416 build-dir = $(patsubst %/,%,$(dir $@))
2417 target-dir = $(dir $@)
2419 zap-slash=$(filter-out .,$(patsubst %/,%,$(dir $@)))
2420 build-dir = $(KBUILD_EXTMOD)$(if $(zap-slash),/$(zap-slash))
2421 target-dir = $(if $(KBUILD_EXTMOD),$(dir $<),$(dir $@))
2424 %.s: %.c prepare scripts FORCE
2425 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2426 %.i: %.c prepare scripts FORCE
2427 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2428 %.o: %.c prepare scripts FORCE
2429 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2430 %.lst: %.c prepare scripts FORCE
2431 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2432 %.s: %.S prepare scripts FORCE
2433 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2434 %.o: %.S prepare scripts FORCE
2435 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2436 %.symtypes: %.c prepare scripts FORCE
2437 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2440 /: prepare scripts FORCE
2442 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2443 $(build)=$(build-dir)
2444 %/: prepare scripts FORCE
2446 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2447 $(build)=$(build-dir)
2448 %.ko: prepare scripts FORCE
2450 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2451 $(build)=$(build-dir) $(@:.ko=.o)
2452 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.modpost
2454 quiet_cmd_genenv = GENENV $@
2455 cmd_genenv = $(OBJCOPY) --dump-section .rodata.default_environment=$@ env/common.o; \
2456 sed --in-place -e 's/\x00/\x0A/g' $@
2458 u-boot-initial-env: u-boot.bin
2459 $(call if_changed,genenv)
2461 # Consistency checks
2462 # ---------------------------------------------------------------------------
2467 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@
2469 # FIXME Should go into a make.lib or something
2470 # ===========================================================================
2472 quiet_cmd_rmdirs = $(if $(wildcard $(rm-dirs)),CLEAN $(wildcard $(rm-dirs)))
2473 cmd_rmdirs = rm -rf $(rm-dirs)
2475 quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),CLEAN $(wildcard $(rm-files)))
2476 cmd_rmfiles = rm -f $(rm-files)
2478 # read all saved command lines
2480 cmd_files := $(wildcard .*.cmd)
2482 ifneq ($(cmd_files),)
2483 $(cmd_files): ; # Do not try to update included dependency files
2484 include $(cmd_files)
2487 endif #ifeq ($(config-targets),1)
2488 endif #ifeq ($(mixed-targets),1)
2489 endif # skip-makefile
2494 # Declare the contents of the PHONY variable as phony. We keep that
2495 # information in a variable so we can use it in if_changed and friends.